Merge pull request #654 from alesliehughes/master
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve gc-descriptors
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         bug-2907.cs             \
48         array-init.cs           \
49         arraylist.cs            \
50         assemblyresolve_event.cs        \
51         assemblyresolve_event3.cs       \
52         checked.cs              \
53         char-isnumber.cs        \
54         create-instance.cs      \
55         field-layout.cs         \
56         pack-layout.cs          \
57         pack-bug.cs             \
58         hash-table.cs           \
59         test-ops.cs             \
60         obj.cs                  \
61         test-dup-mp.cs          \
62         string.cs               \
63         stringbuilder.cs        \
64         switch.cs               \
65         outparm.cs              \
66         delegate.cs             \
67         bitconverter.cs         \
68         exception.cs            \
69         exception2.cs           \
70         exception3.cs           \
71         exception4.cs           \
72         exception5.cs           \
73         exception6.cs           \
74         exception7.cs           \
75         exception8.cs           \
76         exception10.cs          \
77         exception11.cs          \
78         exception12.cs          \
79         exception13.cs          \
80         exception14.cs          \
81         exception15.cs          \
82         exception16.cs          \
83         exception17.cs          \
84         typeload-unaligned.cs   \
85         struct.cs               \
86         valuetype-gettype.cs    \
87         typeof-ptr.cs           \
88         static-constructor.cs   \
89         pinvoke.cs              \
90         pinvoke2.cs             \
91         pinvoke3.cs             \
92         pinvoke11.cs            \
93         pinvoke13.cs            \
94         pinvoke17.cs            \
95         invoke.cs               \
96         invoke2.cs              \
97         runtime-invoke.cs               \
98         invoke-string-ctors.cs          \
99         reinit.cs               \
100         box.cs                  \
101         array.cs                \
102         enum.cs                 \
103         enum2.cs                \
104         property.cs             \
105         enumcast.cs             \
106         assignable-tests.cs     \
107         array-cast.cs           \
108         array-subtype-attr.cs   \
109         cattr-compile.cs        \
110         cattr-field.cs          \
111         cattr-object.cs         \
112         custom-attr.cs          \
113         double-cast.cs          \
114         newobj-valuetype.cs     \
115         arraylist-clone.cs      \
116         setenv.cs               \
117         vtype.cs                \
118         isvaluetype.cs          \
119         iface6.cs               \
120         iface7.cs               \
121         ipaddress.cs            \
122         array-vt.cs             \
123         interface1.cs           \
124         reflection-enum.cs      \
125         reflection-prop.cs      \
126         reflection4.cs          \
127         reflection5.cs          \
128         reflection-const-field.cs \
129         many-locals.cs          \
130         string-compare.cs       \
131         test-prime.cs           \
132         params.cs               \
133         reflection.cs           \
134         interface.cs            \
135         iface.cs                \
136         iface2.cs               \
137         iface3.cs               \
138         iface4.cs               \
139         iface-large.cs          \
140         virtual-method.cs       \
141         intptrcast.cs           \
142         indexer.cs              \
143         stream.cs               \
144         console.cs              \
145         shift.cs                \
146         jit-int.cs              \
147         jit-uint.cs             \
148         jit-long.cs             \
149         long.cs                 \
150         jit-ulong.cs            \
151         jit-float.cs            \
152         pop.cs                  \
153         time.cs                 \
154         appdomain.cs        \
155         appdomain1.cs           \
156         appdomain2.cs           \
157         appdomain-client.cs     \
158         appdomain-unload.cs \
159         appdomain-async-invoke.cs       \
160         loader.cs       \
161         pointer.cs              \
162         hashcode.cs             \
163         delegate1.cs            \
164         delegate2.cs            \
165         delegate3.cs            \
166         delegate5.cs            \
167         delegate6.cs            \
168         delegate7.cs            \
169         delegate8.cs            \
170         delegate9.cs            \
171         remoting1.cs            \
172         remoting2.cs            \
173         remoting3.cs            \
174         remoting4.cs            \
175         remoting5.cs            \
176         largeexp.cs             \
177         largeexp2.cs            \
178         marshalbyref1.cs        \
179         static-ctor.cs          \
180         inctest.cs              \
181         bound.cs                \
182         array-invoke.cs         \
183         test-arr.cs             \
184         decimal.cs              \
185         decimal-array.cs        \
186         marshal.cs              \
187         marshal1.cs             \
188         marshal2.cs             \
189         marshal3.cs             \
190         marshal5.cs             \
191         marshal6.cs             \
192         marshal7.cs             \
193         marshal8.cs             \
194         marshal9.cs             \
195         marshalbool.cs          \
196         marshal-valuetypes.cs   \
197         test-byval-in-struct.cs \
198         thread.cs               \
199         thread5.cs              \
200         thread6.cs              \
201         thread-static.cs        \
202         thread-static-init.cs   \
203         context-static.cs       \
204         float-pop.cs            \
205         interfacecast.cs        \
206         array3.cs               \
207         classinit.cs            \
208         classinit2.cs           \
209         synchronized.cs         \
210         async_read.cs           \
211         threadpool.cs           \
212         threadpool1.cs          \
213         threadpool-exceptions1.cs \
214         threadpool-exceptions2.cs \
215         threadpool-exceptions3.cs \
216         threadpool-exceptions4.cs \
217         threadpool-exceptions5.cs \
218         threadpool-exceptions6.cs \
219         threadpool-exceptions7.cs \
220         base-definition.cs      \
221         bug-27420.cs            \
222         bug-47295.cs            \
223         bug-46781.cs            \
224         bug-48015.cs            \
225         bug-42136.cs            \
226         bug-59286.cs            \
227         bug-70561.cs            \
228         bug-78311.cs            \
229         bug-78653.cs            \
230         bug-78656.cs            \
231         bug-77127.cs            \
232         bug-323114.cs           \
233         bug-Xamarin-5278.cs     \
234         interlocked.cs          \
235         cross-domain.cs         \
236         appdomain-exit.cs       \
237         delegate-async-exit.cs  \
238         delegate-delegate-exit.cs       \
239         delegate-exit.cs        \
240         finalizer-abort.cs      \
241         finalizer-exception.cs  \
242         finalizer-exit.cs       \
243         finalizer-thread.cs     \
244         main-exit.cs    \
245         main-returns-abort-resetabort.cs        \
246         main-returns-background-abort-resetabort.cs     \
247         main-returns-background-resetabort.cs   \
248         main-returns-background.cs      \
249         main-returns-background-change.cs       \
250         main-returns.cs         \
251         subthread-exit.cs       \
252         desweak.cs              \
253         cominterop.cs           \
254         exists.cs               \
255         handleref.cs    \
256         transparentproxy.cs \
257         dbnull-missing.cs       \
258         test-type-ctor.cs       \
259         soft-float-tests.cs     \
260         thread-exit.cs          \
261         finalize-parent.cs      \
262         assemblyresolve_event2.2.cs     \
263         interlocked-2.2.cs      \
264         pinvoke-2.2.cs          \
265         bug-78431.2.cs          \
266         bug-79684.2.cs          \
267         catch-generics.2.cs     \
268         event-get.2.cs          \
269         safehandle.2.cs         \
270         stackframes-async.2.cs          \
271         module-cctor-loader.2.cs        \
272         generics-invoke-byref.2.cs      \
273         generic-signature-compare.2.cs  \
274         generics-sharing.2.cs   \
275         shared-generic-methods.2.cs     \
276         shared-generic-synchronized.2.cs        \
277         generic-inlining.2.cs   \
278         generic-initobj.2.cs    \
279         generic-delegate.2.cs   \
280         generic-sizeof.2.cs     \
281         generic-virtual.2.cs    \
282         generic-interface-methods.2.cs  \
283         generic-array-type.2.cs \
284         generic-method-patching.2.cs    \
285         generic-static-methods.2.cs     \
286         generic-null-call.2.cs  \
287         generic-special.2.cs    \
288         generic-exceptions.2.cs \
289         generic-virtual2.2.cs   \
290         generic-valuetype-interface.2.cs        \
291         generic-getgenericarguments.2.cs        \
292         generic-type-builder.2.cs       \
293         generic-synchronized.2.cs       \
294         generic-delegate-ctor.2.cs      \
295         generic-array-iface-set.2.cs    \
296         generic-typedef.2.cs    \
297         generic-marshalbyref.2.cs       \
298         generic-xdomain.2.cs    \
299         bug-431413.2.cs \
300         bug-459285.2.cs \
301         generic-virtual-invoke.2.cs     \
302         bug-461198.2.cs \
303         generic-sealed-virtual.2.cs     \
304         generic-system-arrays.2.cs      \
305         generic-stack-traces.2.cs       \
306         generic-stack-traces2.2.cs      \
307         bug-472600.2.cs \
308         recursive-generics.2.cs \
309         bug-473482.2.cs \
310         bug-473999.2.cs \
311         bug-479763.2.cs \
312         bug-616463.cs   \
313         bug-80392.2.cs          \
314         dynamic-method-access.2.cs      \
315         dynamic-method-finalize.2.cs    \
316         bug-82194.2.cs  \
317         anonarray.2.cs  \
318         ienumerator-interfaces.2.cs     \
319         array-enumerator-ifaces.2.cs    \
320         generic_type_definition_encoding.2.cs \
321         generic_type_definition.2.cs    \
322         bug-333798.2.cs         \
323         bug-333798-tb.2.cs              \
324         bug-335131.2.cs         \
325         bug-322722_patch_bx.2.cs                \
326         bug-348522.2.cs         \
327         bug-340662_bug.cs       \
328         bug-322722_dyn_method_throw.2.cs        \
329         bug-389886-2.cs \
330         bug-325283.2.cs \
331         thunks.cs \
332         winx64structs.cs \
333         bug-349190.2.cs \
334         nullable_boxing.2.cs    \
335         valuetype-equals.cs     \
336         custom-modifiers.2.cs   \
337         bug-382986.cs   \
338         test-inline-call-stack.cs       \
339         bug-324535.cs   \
340         modules.cs      \
341         bug-81673.cs    \
342         bug-81691.cs    \
343         bug-80307.cs    \
344         bug-415577.cs   \
345         filter-stack.cs \
346         vararg2.cs      \
347         bug-389886-sre-generic-interface-instances.cs   \
348         bug-461867.cs   \
349         bug-461941.cs   \
350         bug-461261.cs   \
351         bug-400716.cs   \
352         bug-462592.cs   \
353         bug-459094.cs   \
354         generic-unloading.2.cs  \
355         generic-unloading-sub.2.cs      \
356         bug-467456.cs   \
357         appdomain-unload-callback.cs    \
358         bug-508538.cs   \
359         bug-472692.2.cs         \
360         gchandles.cs    \
361         interlocked-3.cs        \
362         interlocked-4.2.cs      \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs     \
386         async-with-cb-throws.cs \
387         appdomain-unload-doesnot-raise-pending-events.cs        \
388         bug-6148.cs     \
389         assembly_append_ordering.cs     \
390         bug-10127.cs    \
391         allow-synchronous-major.cs      \
392         unload-appdomain-on-shutdown.cs
393
394 TEST_CS_SRC_DIST=       \
395         $(BASE_TEST_CS_SRC)     \
396         async-exc-compilation.cs \
397         filter-stack.cs \
398         finally_guard.cs
399
400 TEST_CS_SRC_GEN = \
401         runtime-invoke.gen.cs \
402         imt_big_iface_test.cs
403
404 if AMD64
405 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
406 # #651684
407 PLATFORM_DISABLED_TESTS = finally_guard.exe
408 else
409 if X86
410 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
411 else
412 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
413 endif
414 endif
415
416 if IA64
417 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
418 # bug #319249
419 PLATFORM_DISABLED_TESTS=exception17.exe
420 PLATFORM_DISABLED_TESTS+=winx64structs.exe
421 endif
422
423 if X86
424
425 if HOST_WIN32
426 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
427 endif
428
429 endif
430
431 if POWERPC
432 # bug #71274
433 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
434 endif
435
436 if ARM
437 PLATFORM_DISABLED_TESTS=filter-stack.exe
438 endif
439
440 if MIPS
441 # monitor.exe is racy
442 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
443 endif
444
445 if S390x
446 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
447 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
448 endif
449
450 if NACL_CODEGEN
451 # Tests that use Thread.Abort()
452 PLATFORM_DISABLED_TESTS= abort-stress-1.exe \
453                          abort-stress-2.exe \
454                          abort-stress-3.exe \
455                          appdomain-thread-abort.exe \
456                          async-exc-compilation.exe \
457                          bug-561239.exe \
458                          bug-70561.exe \
459                          finalizer-abort.exe \
460                          finally_guard.exe \
461                          main-returns-abort-resetabort.exe \
462                          main-returns-background-abort-resetabort.exe \
463                          thread6.exe \
464                          threadpool-exceptions5.exe \
465                          threadpool-exceptions6.exe
466
467 # Tests that rely on AppDomain.Unload
468 PLATFORM_DISABLED_TESTS+= appdomain-async-invoke.exe \
469                           appdomain-exit.exe \
470                           appdomain-unload-callback.exe \
471                           appdomain-unload.exe \
472                           domain-stress.exe \
473                           generic-unloading.2.exe \
474                           monitor.exe \
475                           remoting4.exe \
476                           threadpool-exceptions7.exe \
477                           xdomain-threads.exe
478
479 # pinvoke2 attaches a thread to the runtime, but
480 # doesn't 'unattach' it and it hangs in GC on exit
481 PLATFORM_DISABLED_TESTS+= pinvoke2.exe
482
483 # Tests that currently hang waiting for non-main threads
484 # to exit in NaCl, need to investigate.  Most are AppDomain
485 # creation and Delegate tests.
486 PLATFORM_DISABLED_TESTS+= appdomain1.exe \
487                           delegate9.exe \
488                           marshal-valuetypes.exe \
489                           cross-domain.exe \
490                           stackframes-async.2.exe \
491                           generic-marshalbyref.2.exe \
492                           generic-xdomain.2.exe \
493                           bug-415577.exe
494
495 # Tests that fail trying to write files (appdomain create mostly)
496 PLATFORM_DISABLED_TESTS+= bug-335131.2.exe \
497                           bug-349190.2.exe \
498                           bug-80307.exe \
499                           bug-462592.exe
500
501 # FIXME: don't know why delegate2.exe fails, it shouldn't
502 PLATFORM_DISABLED_TESTS+= delegate2.exe
503
504 # These tests newly fail with the latest revision. pinvoke3 fails because
505 # of a thread attach, the others have not been investigated.  TODO revisit.
506 PLATFORM_DISABLED_TESTS+= pinvoke3.exe \
507                           async_read.exe \
508                           async-with-cb-throws.exe \
509                           appdomain-unload-doesnot-raise-pending-events.exe \
510                           gsharing-valuetype-layout.exe
511
512 if X86
513 # FIXME: There are problems with async callbacks and results on NaCl 32-bit
514 PLATFORM_DISABLED_TESTS+= delegate1.exe \
515                           delegate3.exe \
516                           delegate5.exe \
517                           delegate8.exe \
518                           threadpool.exe \
519                           threadpool1.exe \
520                           threadpool-exceptions3.exe \
521                           bug-323114.exe \
522                           delegate-exit.exe \
523                           bug-80392.2.exe
524
525 # FIXME: These tests hang/fail for unknown reasons, deal with exiting
526 PLATFORM_DISABLED_TESTS+= main-returns-background-resetabort.exe \
527                           main-returns-background.exe \
528                           main-returns-background-change.exe
529 endif
530
531 endif
532
533 # The two finalizer tests only work under sgen
534 # gc-altstack.exe fails under boehm because it has no support for altstack
535 # bug-459094.exe creates an extremely deep directory tree
536 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
537 # reverted.
538 DISABLED_TESTS=                 \
539         delegate-async-exception.exe    \
540         bug-348522.2.exe        \
541         bug-459094.exe \
542         delegate-invoke.exe \
543         $(PLATFORM_DISABLED_TESTS)
544
545 DISABLED_TESTS_WRENCH=  \
546         $(DISABLED_TESTS)       \
547         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
548         main-returns-background-resetabort.exe \
549         main-returns-background-abort-resetabort.exe    \
550         thread6.exe     \
551         assemblyresolve_event3.exe \
552         delegate2.exe   \
553         finally_guard.exe \
554         gc-altstack.exe
555
556 AOT_DISABLED_TESTS=constraints-load.exe
557
558 # These only compile with MS CSC
559 TEST_CSC_SRC=                   \
560         vararg.cs
561
562 TEST_IL_SRC=                    \
563         field-access.il         \
564         method-access.il        \
565         ldftn-access.il         \
566         cpblkTest.il            \
567         vbinterface.il          \
568         calliTest.il            \
569         ckfiniteTest.il         \
570         fault-handler.il                \
571         locallocTest.il         \
572         initblkTest.il          \
573         qt-instance.il          \
574         vararg.il               \
575         bug-29859.il            \
576         bug-78549.il            \
577         static-fields-nonconst.il       \
578         reload-at-bb-end.il     \
579         test-enum-indstoreil.il \
580         filter-bug.il           \
581         even-odd.il             \
582         bug-82022.il    \
583         vt-sync-method.il       \
584         enum_types.il   \
585         invalid-token.il        \
586         call_missing_method.il  \
587         call_missing_class.il   \
588         ldfld_missing_field.il  \
589         ldfld_missing_class.il  \
590         find-method.2.il        \
591         bug-79215.2.il  \
592         bug-79956.2.il  \
593         bug-327438.2.il \
594         bug-387274.2.il \
595         bug-426309.2.il \
596         ldtoken_with_byref_typespec.2.il \
597         resolve_method_bug.2.il \
598         resolve_field_bug.2.il \
599         resolve_type_bug.2.il   \
600         generics-sharing-other-exc.2.il \
601         generic-ldobj.2.il      \
602         generic-mkrefany.2.il   \
603         generic-refanyval.2.il  \
604         generic-ldtoken.2.il    \
605         generic-ldtoken-method.2.il     \
606         generic-ldtoken-field.2.il      \
607         generic-tailcall.2.il   \
608         generic-tailcall2.2.il  \
609         generic-array-exc.2.il  \
610         generic-valuetype-newobj2.2.il  \
611         generic-valuetype-newobj.2.il   \
612         generic-constrained.2.il        \
613         generic-type-load-exception.2.il        \
614         bug-81466.il    \
615         bug457574.il    \
616         bug445361.il    \
617         bug-463303.il   \
618         bug469742.2.il  \
619         bug-528055.il   \
620         constraints-load.il     \
621         array_load_exception.il \
622         bug-481403.il   \
623         interface-with-static-method.il \
624         bug-515884.il   \
625         bug-633291.il   \
626         delegate-with-null-target.il    \
627         bug-318677.il   \
628         gsharing-valuetype-layout.il    \
629         invalid_generic_instantiation.il
630
631
632 # pre-requisite test sources: files that are not test themselves
633 # but that need to be compiled
634 PREREQ_IL_SRC=event-il.il module-cctor.il
635 PREREQ_CS_SRC=
636 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
637 PREREQ_CS_DLL_SRC=
638
639 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
640 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
641 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
642 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
643 TESTBS=$(BENCHSRC:.cs=.exe)
644 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
645
646 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
647         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
648
649 %.exe: %.il
650         $(ILASM) -out:$@ $<
651
652 %.exe: %.cs TestDriver.dll
653         $(MCS) -r:TestDriver.dll -out:$@ $<
654
655 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
656 if POWERPC
657 test_platform:
658 else
659 # Can't use mkbundle on win32 since there is no static build there
660 # Can't run test-unhandled-exception on Windows because of all the debug popups...
661 if HOST_WIN32
662 test_platform:
663 else
664 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
665 #test_platform: testbundle test-iomap-regression
666 test_platform:  test-iomap-regression
667 endif
668 endif
669
670 if X86
671 if HOST_WIN32
672 else
673 test_platform: test-eglib-remap
674 endif
675 endif
676
677 # Target to precompile the test executables
678 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
679
680 #
681 # Test that no symbols are missed in eglib-remap.h
682 #
683 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
684 if NACL_CODEGEN
685 test-eglib-remap:
686 else
687 test-eglib-remap:
688         @echo "Testing eglib remap..."
689         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
690 endif
691
692 #
693 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
694 # code that checks that the table is properly sorted
695 #
696 if NACL_CODEGEN
697 test-messages:
698 else
699 test-messages: w32message.exe
700         > test_messages.zero
701         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
702 endif
703
704 if MOONLIGHT
705 test_2_1 : test-coreclr-security
706 else
707 test_2_1 :
708 endif
709
710 if AMD64
711 test-sgen : sgen-tests
712 else
713 if X86
714 test-sgen : sgen-tests
715 else
716 if ARM
717 test-sgen : sgen-tests
718 else
719 if S390x
720 test-sgen : sgen-regular-tests
721 endif
722 endif
723 endif
724 endif
725
726 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
727 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
728
729 # Remove empty .stdout and .stderr files for wrench
730 rm-empty-logs:
731         @echo "Removing empty logs..."
732         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
733
734 assemblyresolve/test/asm.dll:
735         $(MAKE) -C assemblyresolve prereq
736
737 TestDriver.dll:
738         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
739
740 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
741         @failed=0; \
742         passed=0; \
743         for i in $(TESTSI_CS); do       \
744                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
745                 then \
746                         passed=`expr $${passed} + 1`; \
747                 else \
748                         if [ $$? = 2 ]; then break; fi; \
749                         failed=`expr $${failed} + 1`; \
750                 fi \
751         done; \
752         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
753
754 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
755         @failed=0; \
756         passed=0; \
757         for i in $(TESTSI_IL); do       \
758                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" 'no-dump' $(RUNTIME_ARGS); \
759                 then \
760                         passed=`expr $${passed} + 1`; \
761                 else \
762                         if [ $$? = 2 ]; then break; fi; \
763                         failed=`expr $${failed} + 1`; \
764                 fi \
765         done; \
766         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
767
768 testb: $(TEST_PROG) $(TESTBS)
769         for i in $(TESTBS); do  \
770                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS);   \
771         done
772
773 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
774         @failed=0; \
775         passed=0; \
776         failed_tests="";\
777         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
778                 rm -f $${i}.so; \
779                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
780                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' 'dump-output' $(RUNTIME_ARGS); \
781                 then \
782                         passed=`expr $${passed} + 1`; \
783                 else \
784                         if [ $$? = 2 ]; then break; fi; \
785                         failed=`expr $${failed} + 1`; \
786                         failed_tests="$${failed_tests} $$i"; \
787                 fi \
788         done; \
789         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
790         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
791           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
792
793 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
794         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
795
796 testjit-wrench:
797         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
798
799 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
800         @failed=0; \
801         passed=0; \
802         failed_tests="";\
803         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
804                 rm -f $${i}.so; \
805                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
806                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
807                 then \
808                         passed=`expr $${passed} + 1`; \
809                 else \
810                         if [ $$? = 2 ]; then break; fi; \
811                         failed=`expr $${failed} + 1`; \
812                         failed_tests="$${failed_tests} $$i"; \
813                 fi \
814         done; \
815         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
816         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
817           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
818
819 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
820         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
821
822 testjit:
823         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
824
825 testaot:
826         @$(MAKE) AOT=1 runtest
827
828 testtrace:
829         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
830
831 testinterp:
832         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
833
834 testjitspeed: $(JITTEST_PROG) $(TESTBS)
835         for i in $(TESTBS); do  \
836                 echo $$i;       \
837                 time $(JITTEST_PROG) $$i;       \
838         done
839
840 test-iomap-regression: exists.cs
841         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
842         @echo "Testing exists.exe..."
843         @MONO_IOMAP=all $(RUNTIME) exists.exe
844
845 stresstest: $(STRESS_TESTS)
846         @failed=0; \
847         passed=0; \
848         failed_tests="";\
849         for i in $(STRESS_TESTS); do    \
850                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
851                 then \
852                         passed=`expr $${passed} + 1`; \
853                 else \
854                         if [ $$? = 2 ]; then break; fi; \
855                         failed=`expr $${failed} + 1`; \
856                         failed_tests="$${failed_tests} $$i"; \
857                 fi \
858         done; \
859         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
860         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
861           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
862
863 testbundle: console.exe
864         @echo "Testing mkbundle..."
865         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
866         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
867         @- rm -rf a.out
868
869 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
870 test-type-load: TestDriver.dll
871         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
872         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
873         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
874         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
875         @echo "Testing load-exception.exe..."
876         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
877
878
879 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs
880
881
882 #those are actually configurations, eg plain_sgen-descriptors.exe
883 #DISABLE_SGEN_TESTS =
884
885 SGEN_TESTS =    \
886         finalizer-wait.exe      \
887         critical-finalizers.exe \
888         sgen-descriptors.exe    \
889         sgen-gshared-vtype.exe  \
890         sgen-domain-unload.exe  \
891         sgen-weakref-stress.exe \
892         sgen-cementing-stress.exe       \
893         sgen-case-23400.exe
894
895 SGEN_CONFIGURATIONS =   \
896         "|plain"        \
897         "major=marksweep-par|ms-par"    \
898         "major=marksweep-conc|ms-conc"  \
899         "major=marksweep-conc,minor=split|ms-conc-split"        \
900         "minor=split|ms-split"  \
901         "minor=split,alloc-ratio=95|ms-split-95"
902
903 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
904 SGEN_BRIDGE_CONFIGURATIONS =    \
905         "|plain"        \
906         ",major=marksweep-conc|ms-conc" \
907         ",minor=split|ms-split"
908
909 sgen-regular-tests: $(SGEN_TESTS)
910         @failed=0; \
911         passed=0; \
912         failed_tests="";\
913         for test in $+; do      \
914                 echo "...$$test";       \
915                 for conf in $(SGEN_CONFIGURATIONS); do  \
916                         name=`echo $$conf | cut -d\| -f 2`;     \
917                         params=`echo $$conf | cut -d\| -f 1`;   \
918                         test_name="$${test}|$${name}";  \
919                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
920                         then \
921                                 passed=`expr $${passed} + 1`; \
922                         else \
923                                 if [ $$? = 2 ]; then break; fi; \
924                                 failed=`expr $${failed} + 1`; \
925                                 failed_tests="$${failed_tests} $$test_name"; \
926                         fi \
927                 done    \
928         done;   \
929         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
930         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
931           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
932
933 sgen-bridge-tests: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
934         @failed=0; \
935         passed=0; \
936         failed_tests="";\
937         for test in $+; do      \
938                 echo "...$$test";       \
939                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
940                         name=`echo $$conf | cut -d\| -f 2`;     \
941                         params=`echo $$conf | cut -d\| -f 1`;   \
942                         test_name="$${test}|$${name}";  \
943                         if MONO_GC_PARAMS="bridge=Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);      \
944                         then \
945                                 passed=`expr $${passed} + 1`; \
946                         else \
947                                 if [ $$? = 2 ]; then break; fi; \
948                                 failed=`expr $${failed} + 1`; \
949                                 failed_tests="$${failed_tests} $$test_name"; \
950                         fi \
951                 done    \
952         done;   \
953         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
954         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
955           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
956
957 sgen-tests: sgen-regular-tests sgen-bridge-tests
958
959
960 # Generated tests for runtime invoke
961 EXTRA_DIST += gen-runtime-invoke.cs
962 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
963         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
964         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
965
966 EXTRA_DIST += make-imt-test.cs
967 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
968         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
969         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
970
971 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
972 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
973         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
974 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
975         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
976
977 EXTRA_DIST += unhandled-exception-base-configuration.config
978 EXTRA_DIST += unhandled-exception-legacy-configuration.config
979 EXTRA_DIST += appdomain-unload.exe.config
980 EXTRA_DIST += unhandled-exception-test-case.2.cs
981 EXTRA_DIST += unhandled-exception-test-runner.2.cs
982 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
983         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
984 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
985         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
986 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
987         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
988 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
989         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
990         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
991         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
992         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
993 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
994         $(MCS) /debug unhandled-exception-test-case.1.cs
995 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
996         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
997 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
998         $(MCS) /debug unhandled-exception-test-case.2.cs
999 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
1000         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
1001 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
1002         $(MCS) /debug unhandled-exception-test-runner.2.cs
1003
1004 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
1005         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
1006
1007 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
1008 bug-80307.exe: $(srcdir)/bug-80307.cs
1009         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
1010         cd $(top_builddir)/runtime && $(MAKE) test-support-files
1011
1012 EXTRA_DIST += bug-81673-interface.cs
1013 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
1014         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1015         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
1016         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
1017
1018 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
1019 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
1020         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
1021         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
1022         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
1023         rm -f bug-81691-a.dll
1024 bug-81691.exe: bug-81691-b.dll
1025
1026 EXTRA_DIST += bug-81466-lib.il
1027 bug-81466-lib.dll: bug-81466-lib.il
1028         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
1029 bug-81466.exe: bug-81466.il bug-81466-lib.dll
1030         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
1031
1032 EXTRA_DIST += bug-324535-il.il
1033 bug-324535-il.dll : bug-324535-il.il
1034         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
1035 bug-324535.exe : bug-324535.cs bug-324535-il.dll
1036         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
1037
1038 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
1039 custom-modifiers-lib.dll: custom-modifiers-lib.il
1040         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
1041 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
1042         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
1043
1044 EXTRA_DIST += bug-382986-lib.cs
1045 bug-382986-lib.dll: bug-382986-lib.cs
1046         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
1047 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
1048         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
1049
1050 EXTRA_DIST += coreclr-security.cs
1051
1052 if MOONLIGHT
1053 coreclr-security.exe : coreclr-security.cs
1054         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
1055
1056 test-coreclr-security : coreclr-security.exe
1057         @echo "Testing coreclr-security.exe..."
1058         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
1059 endif
1060
1061 EXTRA_DIST += generic-unboxing.2.il
1062 generic-unboxing.2.dll : generic-unboxing.2.il
1063         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
1064
1065 EXTRA_DIST += generic-boxing.2.il
1066 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
1067         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
1068
1069 EXTRA_DIST += generic-unbox.2.cs
1070 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
1071         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
1072
1073 EXTRA_DIST += generic-box.2.cs
1074 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
1075         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
1076
1077 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
1078 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
1079         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
1080 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
1081         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
1082
1083 bug-3903.exe: bug-3903.cs
1084         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1085
1086 gshared: test-generic-sharing
1087
1088 gshared-aot:
1089         @$(MAKE) AOT=1 gshared
1090
1091 GSHARED_TESTS = \
1092                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1093                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1094                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1095                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1096                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1097                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1098                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1099                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1100                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1101                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1102                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1103                 generic-array-exc.2.exe generic-special.2.exe                   \
1104                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1105                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1106                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1107                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1108                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1109                 generic-constrained.2.exe bug-431413.2.exe                      \
1110                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1111                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1112                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1113                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1114                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1115                 bug-479763.2.exe generic-xdomain.2.exe                          \
1116                 generic-type-load-exception.2.exe bug-616463.exe        \
1117                 bug-1147.exe
1118
1119 test-generic-sharing-normal: $(GSHARED_TESTS)
1120         @for fn in $+ ; do      \
1121                 echo "Testing $$fn ...";        \
1122                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
1123                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1124                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1125                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1126                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1127         done
1128
1129 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1130         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1131
1132 if NACL_CODEGEN
1133 test-generic-sharing:
1134 else
1135 test-generic-sharing:
1136         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1137 endif
1138
1139 EXTRA_DIST += async-exceptions.cs
1140 async-exceptions.exe : async-exceptions.cs
1141         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1142 test-async-exceptions : async-exceptions.exe
1143         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1144         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1145
1146 EXTRA_DIST += modules.cs modules-m1.cs
1147 modules-m1.netmodule: modules-m1.cs
1148         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1149 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1150         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1151
1152 # Useful if mono is compiled with --enable-shared=no
1153 patch-libtool:
1154         cp "../../libtool" .
1155         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1156         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1157         touch libtest.c
1158
1159
1160 if NACL_CODEGEN
1161 test-process-exit:
1162 else
1163 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1164 test-process-exit:
1165         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1166         @echo "Testing bug-438454.exe..."
1167         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1168         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1169         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1170         @echo "Testing threadpool-in-processexit.exe..."
1171         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1172         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1173 endif
1174
1175 OOM_TESTS =     \
1176         gc-oom-handling.exe     \
1177         gc-oom-handling2.exe
1178
1179
1180 test-oom: $(OOM_TESTS)
1181         @for fn in $+ ; do      \
1182                 echo "Testing $$fn ...";        \
1183                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1184                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1185                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1186         done
1187
1188
1189 noinst_LTLIBRARIES = libtest.la
1190
1191 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1192
1193 if HOST_WIN32
1194 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1195 # This shows up when compiling mono_test_marshal_delegate ()
1196 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1197 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1198 # can't find them. So we use --kill-at to remove the @ suffix as well.
1199 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1200 else
1201 libtest_la_LDFLAGS = -rpath `pwd`
1202 endif
1203 libtest_la_SOURCES = libtest.c
1204 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1205
1206 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat